--Use this to track down textures, folder general_unpack
dbg_tpath = "a:\\SteamLibrary\\SteamApps\\common\\Just Cause 2\\just cause 2\\bin\\exported\\pc01\\global\\areasets\\general_unpack\\"
fn ErrorMessage text =
(
	local msg = ("ERROR: " + text + "\n")
	format "%\n" msg
	messageBox msg
    --throw msg
)
fn ReadAbsCharsToHex file numchars = (
	SOutput = ""
	for v=1 to numchars do(
		SOutput += (bit.intAsHex(abs (readbyte file) ))as string	
	)	
	SOutput	
)
fn ReadTexture f =(
	SOutput = ""
	for v=1 to 64 while (matchPattern SOutput pattern:"*.dds") == false do (
		SOutput += bit.intAsChar (readbyte f)			
	)
	SOutput
	
)
fn GetFloatFromShort num = (
	(num * (1.0 / 32767)) as float
)

fn GetPoint3Color2 f = (
	IFloat = readfloat f	
	iX = IFloat
	iY = IFloat/64
	iZ = IFloat/4096
	iX -=  Floor iX;iX*=255 
	iY -=  Floor iY;iY*=255
	iZ  -= Floor iZ;iZ*=255
	[iX,iY,iZ]
)

fn GetPoint3Vector f = (
	IFloat = readfloat f	
	iX = IFloat
	iY = IFloat/256
	iZ = IFloat/65536
	iX -=  Floor iX;iX*=2;iX-=1 
	iY -=  Floor iY;iY*=2;iY-=1 
	iZ  -= Floor iZ;iZ*=2;iZ-=1
	[iZ,iX,iY]
)
fn ProcessFace f =(
	Face_array=#()
	icount = readlong f
	for x = 1 to icount/3 do (
		fa=readshort f #unsigned+1
		fb=readshort f #unsigned+1
		fc=readshort f #unsigned+1
		append Face_array[fa,fb,fc]
	)
	Face_array	
)
dbg_scale = 20
fn GeneralBlock f = (
	ShaderArray = #()
	Shader_Flags = #()
	NormalArray = #()
	Vert_array=#()
	UV_array=#()
	UV2_array=#()
	Color_array=#()
	version = readbyte f
	fseek f 36 #seek_cur	
	unk1 = readfloat f
	vertextype = readlong f
	vscale = readfloat f
	usc = readfloat f
	vsc = readfloat f	
	usc2 = readfloat f
	vsc2 = readfloat f	
	unk2 = readfloat f
		if version == 3 then fseek f 8 #seek_cur
	for v = 1 to 4 do (
		append Shader_Flags (readlong f)
		append ShaderArray (ReadTexture f)
	)
fseek f 16 #seek_cur
mver = readlong f
count = readlong f
for v = 1 to count do (
	if vertextype == 1 then (
		u=GetFloatFromShort (readshort f)*usc
		v=GetFloatFromShort (readshort f)*vsc
		u2=GetFloatFromShort (readshort f)*usc2
		v2=GetFloatFromShort (readshort f)*vsc2
		append NormalArray (GetPoint3Vector f)
		Tang = GetPoint3Vector f
		append Color_array (GetPoint3Color2 f	)
		vpx =GetFloatFromShort (readshort f)
		vpy =GetFloatFromShort (readshort f)
		vpz =GetFloatFromShort (readshort f)
		fseek f 2 #seek_cur
		append Vert_array([vpz,vpx,vpy] *vscale*dbg_scale)	
		append UV_array([u,-v,0])	
		append UV2_array([u2,-v2,0])	
	)	
	else throw "BigVertex"
)
	Face_array = (ProcessFace f)

msh = mesh vertices:Vert_array faces:Face_array
for j = 1 to NormalArray.count do setNormal msh j NormalArray[j]
meshop.setNumMaps msh 3
meshop.setNumMapVerts msh 2 UV2_array.count
meshop.buildMapFaces msh 2
for j = 1 to UV2_array.count do meshop.setMapVert msh 2 j UV2_array[j]
meshop.setNumMapVerts msh 1 UV_array.count
meshop.buildMapFaces msh 1
for j = 1 to UV_array.count do meshop.setMapVert msh 1 j UV_array[j]
meshop.setNumCPVVerts msh Color_array.count
for j = 1 to Color_array.count do setVertColor msh j Color_array[j]
diff1 = bitmaptexture name: ShaderArray[1] 
diff1.filename= dbg_tpath+ShaderArray[1]
modyfi = rgbtint name: ShaderArray[1]
modyfi.map1 = diff1
	if Shader_Flags[1] == 24 then (
			modyfi.red = [255,255,255]
			modyfi.blue = [0,0,0]
			modyfi.green = [0,0,0]
	)

diff2 = bitmaptexture name: ShaderArray[4] 
diff2.filename= dbg_tpath+ShaderArray[4]
diff2.coords.mapchannel = 2
diff3 = vertexcolor name: ShaderArray[1]
mat = standardmaterial name:"GeneralObject"
	mat.diffusemap = compositeMap name: #(ShaderArray[1] ,ShaderArray[4] ,ShaderArray[1] )
	mat.diffusemap.maplist = #(modyfi,diff2,diff3)
	mat.diffusemap.blendMode = #(5,5,5) 
	mat.bumpmap = bitmaptexture name:ShaderArray[2]
	mat.bumpmap.filename = dbg_tpath+ShaderArray[2]
	mat.opacitymap = bitmaptexture name:ShaderArray[1]
	mat.opacitymap.filename = dbg_tpath+ShaderArray[1]
	mat.opacitymap.RGBOutput = 1
	mat.opacitymap.monoOutput =1
	mat.specularLevelMap  = bitmaptexture name:ShaderArray[3]
	mat.specularLevelMap .filename = dbg_tpath+ShaderArray[3]
	mat.specularLevel = unk1
	showtexturemap mat true
msh.material = mat 
)

fn CheckBlockEnd f = (
	if ReadAbsCharsToHex f 4 != "11335577" then (
		format "Wrong End of Block at [ % ]\n"   (ftell f) -4
		throw "Missing End of Block!"
	)
)
fn FacadeBlock f = (
	ShaderArray = #()
	Vert_array=#()
	UV_array=#()
	version = readbyte f
	fseek f 48 #seek_cur
	type = readlong f
	fseek f 8 #seek_cur	
	for v = 1 to 4 do (
		fseek f 4 #seek_cur
		append ShaderArray (ReadTexture f)
	)
	fseek f 16 #seek_cur
	mver = readlong f
	vcount = readlong f
	print version
	for v = 1 to vcount do (
		if version == 1 then (
			u=GetFloatFromShort (readshort f)
			v=GetFloatFromShort (readshort f)
			u=GetFloatFromShort (readshort f)
			v=GetFloatFromShort (readshort f)
			u=readfloat f
			v=readfloat f
			ufloat = readfloat f	
			ufloat = readfloat f	
			
			vpx1 =GetFloatFromShort (readshort f)
			vpy1 =GetFloatFromShort (readshort f)
			vpz1 =GetFloatFromShort (readshort f)
			vpw1 =GetFloatFromShort (readshort f)
			
			vpx2 =GetFloatFromShort (readshort f)
			vpy2 =GetFloatFromShort (readshort f)
			vpz2 =GetFloatFromShort (readshort f)
			vpw2 =GetFloatFromShort (readshort f)

			
			append Vert_array([vpx1,vpy1,vpw1] *16)	
			append UV_array([u,v,0])	
		)		
	)
	Face_array = (ProcessFace f)
	msh = mesh vertices:Vert_array faces:Face_array
	msh.numTVerts = UV_array.count
	buildTVFaces msh
	for j = 1 to UV_array.count do setTVert msh j UV_array[j]
)
fn HaloBlock f = (
	NormalArray = #()
	Vert_array=#()
	UV_array=#()
	version = readbyte f
	mfalg = readlong f
	texture = ReadTexture f
	fseek f 28 #seek_cur
	mver = readlong f
	vcount = readlong f
	for v = 1 to vcount do (
		vpx = readfloat f
		vpy =readfloat f
		vpz =readfloat f
		vpx11 = readshort f
		vpx1 =GetFloatFromShort (readshort f)
		vpy1 =GetFloatFromShort (readshort f)
		vpz1 =GetFloatFromShort (readshort f)
		append Vert_array([vpz,vpx,vpy] )	
		-- looks like vpx vpy vpz vpx1 vpy1 vpz1 have same value series
	)	
	Face_array = (ProcessFace f)
--msh = mesh vertices:Vert_array faces:Face_array
)
fn CarPaintSimpleBlock f = (
	ShaderArray = #()
	Shader_Flags = #()
	Vert_array=#()
	UV_array=#()
	UV2_array=#()
	version = readbyte f
	fseek f 56 #seek_cur
	for v = 1 to 3 do (
		append Shader_Flags (readlong f)
		append ShaderArray (ReadTexture f)
	)
	fseek f 20 #seek_cur
	mver = readlong f
	count = readlong f
for v = 1 to count do (
	vpx = readfloat f
	vpy = readfloat f
	vpz = readfloat f
	vpw = readfloat f
	u = readfloat f
	v = readfloat f
	u2 = readfloat f
	v2 = readfloat f
		append Vert_array([vpz,vpx,vpy] *dbg_scale)	
		append UV_array([u,-v,0])	
		--append UV2_array([u2,-v2,0])	
	)	
	Face_array = (ProcessFace f)
msh = mesh vertices:Vert_array faces:Face_array
msh.numTVerts = UV_array.count
buildTVFaces msh
for j = 1 to UV_array.count do setTVert msh j UV_array[j]	
for j = 1 to Face_array.count do setTVFace msh j Face_array[j]
mat = standardmaterial name:"CPSimpleObject"
	mat.diffusemap = bitmaptexture name:ShaderArray[1]
	mat.diffusemap.filename = dbg_tpath+ShaderArray[1]
	mat.bumpmap = bitmaptexture name:ShaderArray[2]
	mat.bumpmap.filename = dbg_tpath+ShaderArray[2]
	mat.specularLevelMap  = bitmaptexture name:ShaderArray[3]
	mat.specularLevelMap .filename = dbg_tpath+ShaderArray[3]
	mat.opacitymap = bitmaptexture name:ShaderArray[1]
	mat.opacitymap.filename = dbg_tpath+ShaderArray[1]
	mat.opacitymap.RGBOutput = 1
	mat.opacitymap.monoOutput =1
	showtexturemap mat true
msh.material = mat 		
)

fn VegetationBarkBlock f = (
	version = readbyte f
	ulong1 = readlong f
	ShaderArray = #()
	Shader_Flags = #()
	for v = 1 to 4 do (
		append Shader_Flags (readlong f)
		append ShaderArray (ReadTexture f)
	)
	fseek f 16 #seek_cur
	mver = readlong f
	count = readlong f
	for v = 1 to count do (
		fseek f 32 #seek_cur	
	)	
	Face_array = (ProcessFace f)	
)
fn VegetationFolBlock f =(
	ShaderArray = #()
	Shader_Flags = #()
	version = readbyte f
	fseek f 24 #seek_cur
	for v = 1 to 3 do (
		append Shader_Flags (readlong f)
		append ShaderArray (ReadTexture f)
	)
	fseek f 20 #seek_cur
	mver = readlong f
	count = readlong f
	for v = 1 to count do (
		fseek f 40 #seek_cur	
	)	
	Face_array = (ProcessFace f)		
)

fn LambertBlock f =(
	ShaderArray = #()
	Shader_Flags = #()
	Vert_array=#()
	UV_array=#()
	version = readbyte f
	flags = readlong f
	fseek f 40 #seek_cur	
	for v = 1 to 3 do (
		append Shader_Flags (readlong f)
		append ShaderArray (ReadTexture f)
	)
	fseek f 20 #seek_cur
	mver = readlong f
	count = readlong f
	for v = 1 to count do (
		if flags == 1 then (
			u=GetFloatFromShort (readshort f)
			v=GetFloatFromShort (readshort f)
			fseek f 16 #seek_cur
			vpx =GetFloatFromShort (readshort f)
			vpy =GetFloatFromShort (readshort f)
			vpz =GetFloatFromShort (readshort f)
			fseek f 2 #seek_cur
			append Vert_array([vpz,vpx,vpy] *dbg_scale)	
			append UV_array([u,-v,0])	
			
		)
		else throw "BigLambert"
	)	
	Face_array = (ProcessFace f)		
	msh = mesh vertices:Vert_array faces:Face_array
	msh.numTVerts = UV_array.count
	buildTVFaces msh
	for j = 1 to UV_array.count do setTVert msh j UV_array[j]	
	for j = 1 to Face_array.count do setTVFace msh j Face_array[j]

mat = standardmaterial name:"LambertObject"
	mat.diffusemap = bitmaptexture name:ShaderArray[1]
	mat.diffusemap.filename = dbg_tpath+ShaderArray[1]
	mat.bumpmap = bitmaptexture name:ShaderArray[2]
	mat.bumpmap.filename = dbg_tpath+ShaderArray[2]
	mat.specularLevelMap  = bitmaptexture name:ShaderArray[3]
	mat.specularLevelMap .filename = dbg_tpath+ShaderArray[3]
	mat.opacitymap = bitmaptexture name:ShaderArray[1]
	mat.opacitymap.filename = dbg_tpath+ShaderArray[1]
	mat.opacitymap.RGBOutput = 1
	mat.opacitymap.monoOutput =1
	showtexturemap mat true
msh.material = mat 		
)

fn DecryptNumber num encryptor =(
	intnum = (num/encryptor) as integer
	restnum = (num-(encryptor*intnum)) as float
	#(intnum,restnum)
)

fn EncryptNumber intnum floatnum encryptor =(
	(intnum*encryptor+floatnum) as float
)

fn EncryptColor r g b a pres =(		
	out = 0
    out += r * pres^3 * (pres-1)
    out += g * pres^2 * (pres-1)
    out += b * pres * (pres-1)
    out += a * (pres-1)
	out	
)
fn DecryptColor inum pres =(
    ColorArray = inum*(1/pres)
	ColorArray
)
/*print(EncryptColor 120 130 140 150 4)
print(DecryptColor 31410 4)*/

fname = getOpenFileName \
caption:"Open Model file" \
types:"Avalanche rbm (*.rbm)|*.rbm" \
historyCategory:"PMSH_JC2RBM"
--dbg_tpath = getFilenamePath fname
f = fopen fname "rb"
clearlistener()
fseek f 45 #seek_set
blockcount = readlong f

format "Number of blocks: %\n"  blockcount
for v = 1 to blockcount do(	
	blocktype = ReadAbsCharsToHex f 4
	
	if blocktype == "2b3b5859" then (
		GeneralBlock f	
		CheckBlockEnd f
	)	
	else if blocktype == "41293932" then ( 
		FacadeBlock f
		CheckBlockEnd f
	)
	else if blocktype == "4e4b2765" then ( 
		HaloBlock f
		CheckBlockEnd f
	)
	else if blocktype == "707c6d7f" then ( 
		CarPaintSimpleBlock f
		CheckBlockEnd f
	)
	else if blocktype == "3d1374f" then ( 
		VegetationBarkBlock f
		CheckBlockEnd f
	)
	else if blocktype == "3a7c6829" then ( 
		VegetationFolBlock f
		CheckBlockEnd f
	)
	else if blocktype == "2076292b" then ( 
		LambertBlock f
		CheckBlockEnd f
	)
	else (
		format  "Unknown Block type % no % at [ % ]\n" blocktype v ((ftell f)-4) 		
		throw   "Unknown Block type!" 
	)
	
)
fclose f
